--demochar.e
--demonstration of char.e character drawing program

include char.e --includes graphx.e
integer kbd
set_graphics(18,15) --mode 18, white background
show_graphics_info()
show_chars()
text_attributes(1,8,0,0)
graphics_text("<--Show_graphics_info() gives information on the graphics mode.",{.25,.07},1,1)
text_attributes(2,8,0,0)
graphics_text("These are all the",{.6,.3},1,1)
graphics_text("characters you",{.6,.35},1,1)
graphics_text("can make.  Press",{.6,.4},1,1)
graphics_text("any key to con-",{.6,.45},1,1)
graphics_text("tinue...",{.6,.5},1,1)
while 1 do
    kbd=get_key()
    if kbd>0 then
	exit
    end if
end while
rectangle(1,{0,0},{1,1})
text_attributes(1,2,0,0)
graphics_text("Text can be any size and any color supported by the graphics mode.  It",{.1,.1},1,1)
graphics_text("can be fixed width:",{.05,.15},1,1)
text_attributes(1,7,0,0)
graphics_text("The quick brown fox jumped over the old lazy dog.",{.5,.25},0,0)
text_attributes(1,2,0,0)
graphics_text("or proportionally spaced:",{.05,.35},1,1)
text_attributes(1,7,0,0)
graphics_text("The quick brown fox jumped over the old lazy dog.",{.5,.45},0,1)
text_attributes(1,2,0,0)
graphics_text("You can also print in ",{.05,.55},1,1)
text_attributes(1,2,1,0)
continue_text("bold",1)
text_attributes(1,2,0,0)
continue_text(" or in ",1)
text_attributes(1,2,0,1)
continue_text("italics.",1)
text_attributes(1,2,0,0)
continue_text("  At scale=1, the characters are 7 pixels",1)
graphics_text("across and 9 pixels high, not counting descenders or accent marks.  The scale",{.05,.6},1,1)
graphics_text("can be any number, even less than one, but the characters will get hard to",{.05,.65},1,1)
graphics_text("read if they get too small:",{.05,.7},1,1)
for n=20 to 1 by -1 do
    text_attributes(n/10,7,0,0)
    continue_text(" R",1)
end for
rectangle(4,{.3,.85},{.7,.95})
text_attributes(1,14,0,0)
graphics_text("Press any key to continue...",{.5,.9},0,1)
while 1 do
    kbd=get_key()
    if kbd>0 then
	exit
    end if
end while
rectangle(7,{0,0},{1,1})
text_attributes(1,8,0,0)
graphics_text("If you want the text to be black, use 8 for the color, not 0 (Color=0 makes",{.1,.05},1,1)
graphics_text("the text the same color as the background).  If you call set_graphics, the",{.05,.1},1,1)
graphics_text("palette is changed so that color 8 is black.  The routines should work on any",{.05,.15},1,1)
graphics_text("color graphics screen, but the characters will be smaller if you are using a",{.05,.2},1,1)
graphics_text("higher resolution, like 800x600 (mode 258), or 1024x768 (mode 260).",{.05,.25},1,1)
graphics_text("The third parameter of graphics_text sets the justification: left if the num-",{.1,.3},1,1)
graphics_text("ber is positive, right if negative, or centered if zero.  The screen position in",{.05,.35},1,1)
graphics_text("the second parameter can be the actual pixel position, or will be considered a",{.05,.4},1,1)
graphics_text("proportion of the screen size if the number is between zero and one.",{.05,.45},1,1)
graphics_text("If you need a character that is not included, and you don't want to create",{.1,.5},1,1)
graphics_text("one, you can put any of sixteen different accents over (or under) any charac-",{.05,.55},1,1)
graphics_text("ter by using put_accent.  If the character is not full height, the accent mark is",{.05,.6},1,1)
graphics_text("moved down to the correct position.  So, if you want to write something in Hun-",{.05,.65},1,1)
graphics_text("garian, and you need an o",{.05,.7},1,1)
put_accent(10)
continue_text(", just make a regular o and then add the accent (#10).",1)
graphics_text("Any time you stop in a row and then want to continue from the same point, you can",{.05,.75},1,1)
graphics_text("use the continue_text function.",{.05,.8},1,1)
graphics_text("The rectangle function draws a filled rectangle of the specified color between",{.1,.85},1,1)
graphics_text("two points representing two opposite corners.  It can be used to clear the screen,",{.05,.9},1,1)
rectangle(2,{.3,.94},{.7,.98})
text_attributes(1,15,0,0)
graphics_text("Press any key to continue...",{.5,.96},0,1)
while 1 do
    kbd=get_key()
    if kbd>0 then
	exit
    end if
end while
rectangle(7,{0,0},{1,.7})
text_attributes(1,8,0,0)
graphics_text("or just part of the screen.  The screen position, again, can be either actual pixels,",{.05,.05},1,1)
graphics_text("or a proportion of the total screen width or height.",{.05,.1},1,1)
graphics_text("Note that the characters need not stop at 255 (the accent characters are",{.1,.15},1,1)
graphics_text("stored from 256 to 271).  If higher numbers are used, the graphics_text function",{.05,.2},1,1)
graphics_text("would have to be called using a sequence of numbers, instead of a quoted string.",{.05,.25},1,1)
text_attributes(5,1,1,0)
graphics_text("THE END",{.5,.4},0,1)
text_attributes(1,1,0,0)
graphics_text("(Press any key...)",{.5,.55},0,1)
while 1 do
    kbd=get_key()
    if kbd>0 then
	exit
    end if
end while
reset_graphics()

